#!/usr/bin/env python

#############################################################################
# Author: Enrico Trotta <enrico.trt@gmail.com>
#############################################################################
# 
# pyWebcheck is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################


import gtk
import gtk.glade
import pygtk
from ftplib import FTP
import os
import filecmp
import MessageBox 
from sys import exit

try: 
	from pynotify import *
except: 
	ImportError

pygtk.require("2.0")

class ftp_conn:

	def save_dir(self, mode):
		if mode == 1: # update the directory tree
			self.dat = []
			self.ftp.dir(self.dat.append)
			self.file_list = open(".list","wb")
			for x in self.dat:
				self.file_list.write(x + "\n")
			self.file_list.close()

		elif mode == 2: # get the new directory tree to compare
			self.file_list_new = open(".list_new","w")
			self.data_compare = []
			self.ftp.dir(self.data_compare.append)
			self.file_list_new = open(".list_new","wb")
			for x in self.data_compare:
				self.file_list_new.write(x + "\n")
			self.file_list_new.close()

	def compare_file(self):
		if filecmp.cmp(".list",".list_new") == True:
			messageBox.run(window1, "Informazione", "Nessun file e' stato aggiornato.")
			messageBox.destroy()
		else:
			messageBox.run(window1, "Informazione", "Alcuni file sono stati aggiornati.")
			messageBox.destroy()

	def connect(self):
		self.host = hostname.get_text()
		uri_online = "file://" + os.path.abspath(os.path.curdir) + "/../data/icons/online.png"
		try: 
			self.ftp = FTP(hostname.get_text())
			self.ftp.login(username.get_text(), password.get_text())
			if init("Connection OK"):
				conn_ok = Notification("pyWebcheck", "Connessione stabilita con successo con %s." % self.host, uri_online)
				conn_ok.set_timeout(2500)
				conn_ok.show()
			else: 
				exit("Impossibile inizializzare il modulo pynotify.")
		except: 
			if (hostname.get_text() == '' or username.get_text() == '' or password.get_text == ''):
				messageBox.run(window1, "Errore", "Devi compilare tutti i campi richiesti per la connessione.")
				messageBox.destroy()
			else: 
				messageBox.run(window1, "Errore", "Impossibile eseguire la connessione.")
				messageBox.destroy() 
		
		if first_time == True:
			self.save_dir(1)

		self.save_dir(2)
		self.compare_file()
	
	def refresh(self):
		uri_refresh = "file://" + os.path.abspath(os.path.curdir) + "/../data/icons/refresh.png"
		try:
			self.save_dir(1)
			if init("Refresh OK"):
				drefresh = Notification("pyWebcheck", "La lista dei file sul server %s e' stata aggiornata." % self.host, uri_refresh)
				drefresh.set_timeout(1500)
				drefresh.show()	
			else:
				exit("Impossibile inizializzare il modulo pynotify.")
		except:
			messageBox.run(window1, "Errore", "Impossibile aggiornare la lista di file. Probabilmente non e' possibile collegarsi al server.")
			messageBox.destroy() 
	

	def quit(self):
		uri_offline = "file://" + os.path.abspath(os.path.curdir) + "/../data/icons/offline.png"
		try:
			self.ftp.quit()
			if init("Disconnection OK"):
				dconn_ok = Notification("pyWebcheck", "Disconnessione eseguita con successo da %s." % self.host, uri_offline)
				dconn_ok.set_timeout(1500)
				dconn_ok.show()
			else: 
				exit("Impossibile inizializzare il modulo pynotify.")
		except:
			messageBox.run(window1, "Errore", "Non e' stata stabilita nessuna conessione da interrompere.")
			messageBox.destroy() 
			
class Widgets:
	
	def clean1_clicked_cb(widget, data=None):
		hostname.set_text("")
	def clean2_clicked_cb(widget, data=None): 
		username.set_text("")
	def clean3_clicked_cb(widget, data=None): 
		password.set_text("")
	def imagemenuitem10_activate_cb(widget, data=None):
		about.show()
	def pulisci_menu_activate_cb(widget, data=None):
		hostname.set_text("")
		username.set_text("")
		password.set_text("")
	def check_welcome_toggled_cb(widget, data=None):
		welcome_message = 1
		
	
		
def button1_clicked_cb(widget, data=None):
	ftp_.connect()
	if check_welcome.get_active() == True:
		print ftp_.ftp.getwelcome()

def button2_clicked_cb(widget, data=None):
	ftp_.quit()

def button3_clicked_cb(widget, data=None):
	window1.destroy()

def button4_clicked_cb(widgets, data=None):
	ftp_.refresh()

def on_window1_destroy(widget, data=None):
  	gtk.main_quit()

# Dichiarazione dell classi

ftp_ = ftp_conn()
widgets = Widgets()
messageBox = MessageBox.messagebox()

signal = {
	'on_window1_destroy': on_window1_destroy,
  	'button1_clicked_cb': button1_clicked_cb,
  	'button2_clicked_cb': button2_clicked_cb,
  	'button3_clicked_cb': button3_clicked_cb,
	'button4_clicked_cb': button4_clicked_cb,
	'clean1_clicked_cb': widgets.clean1_clicked_cb,
	'clean2_clicked_cb': widgets.clean2_clicked_cb,
	'clean3_clicked_cb': widgets.clean3_clicked_cb,
	'imagemenuitem10_activate_cb': widgets.imagemenuitem10_activate_cb,
	'pulisci_menu_activate_cb': widgets.pulisci_menu_activate_cb,
	'check_welcome_toggled_cb': widgets.check_welcome_toggled_cb
}

gladeFile = gtk.glade.XML('../data/ui/UI.glade')
window1 = gladeFile.get_widget('window1')
about = gladeFile.get_widget('aboutdialog')
gladeFile.signal_autoconnect(signal)

first_time = False

hostname = gladeFile.get_widget('hostname')
username = gladeFile.get_widget('username')
password = gladeFile.get_widget('password')
check_welcome = gladeFile.get_widget('check_welcome')

if os.path.exists(".list") == False:
	messageBox.run(window1, "Informazione", "Sembra sia la prima volta che avvii pyWebcheck.\n"
				"Da questo momento verranno creati i file di configurazione e"
				"potrai utilizzare le funzioni del software.")
	messageBox.destroy()
	first_time = True
	file_list = open(".list","w")

if window1:
  window1.show()
  gtk.main()
